import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
--Turbine.Shell.WriteLine( "Start" );
--Creating the controls
	MainWindow = class( Turbine.UI.Window );
	Date = Turbine.Engine.GetDate();
	LabelEarned2 = Turbine.UI.Label();
	
	Year = "";
	Month = "";
	Day = "";
	PrevDay = "";
	TotalString = "";
	TotalDate = "";
	
	GoldCollected = 0;
	SilverCollected = 0;
	CopperCollected = 0;
	RenownCollected = 0;
	Page = 1;
	
	NextDay = false;
	
	ArrayData = {};
	
function MainWindow:Constructor()
	
	Turbine.UI.Lotro.Window.Constructor( self );
	
	--We want to let the Escape button trigger the disappearing of the screens
		self:SetWantsKeyEvents( true );
	
	--Creating the window
		self.minWidth = 420;
		self.minHeight = 500;
		self:SetPosition(300,300);	
		self:SetSize( 420, 500 );
		self:SetBackColor( Turbine.UI.Color(0.0,0,0,0) );
		self:SetOpacity( 8 );
		self:SetText( "Goldtracker" );
		self.disableResize = true;

	--Get the current day
		MainWindow:GetDate()

	--Adding controls
		LabelDate = Turbine.UI.Label();
		LabelDate:SetText( "Current day: ".. Day .. "/" .. Month .. "/" .. Year );
		LabelDate:SetSize(270, 15 );
		LabelDate:SetPosition(30, 35 );
		LabelDate:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelDate:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelDate:SetParent( self );
		LabelDate:SetVisible( true );

		LabelEarned = Turbine.UI.Label();
		LabelEarned:SetText( "Earned:" );
		LabelEarned:SetSize(50, 15 );
		LabelEarned:SetPosition(200, 35 );
		LabelEarned:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelEarned:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelEarned:SetParent( self );
		LabelEarned:SetVisible( true );
		
		LabelEarned2:SetText( "G:0 S:0 C:0" );
		LabelEarned2:SetSize(130, 15 );
		LabelEarned2:SetPosition(260, 35 );
		LabelEarned2:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelEarned2:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelEarned2:SetParent( self );
		LabelEarned2:SetVisible( true );
		
		LabelListDate = Turbine.UI.Label();
		LabelListDate:SetText( "Day: " );
		LabelListDate:SetSize(50, 15 );
		LabelListDate:SetPosition(30, 55 );
		LabelListDate:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelListDate:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelListDate:SetParent( self );
		LabelListDate:SetVisible( true );
		
		LabelListGold = Turbine.UI.Label();
		LabelListGold:SetText( "Earned: " );
		LabelListGold:SetSize(50, 15 );
		LabelListGold:SetPosition(100, 55 );
		LabelListGold:SetBackColor( Turbine.UI.Color(0.9,0,0,0) );
		LabelListGold:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
		LabelListGold:SetParent( self );
		LabelListGold:SetVisible( true );

	--Making the listbox
		self.ListboxGoldEarned = Turbine.UI.ListBox();
		self.ListboxGoldEarned:SetParent( self );
		self.ListboxGoldEarned:SetSize( 350, 350 );
		self.ListboxGoldEarned:SetPosition( 30, 70 );
		self.ListboxGoldEarned:SetBackColor(Turbine.UI.Color(0.91,0,0,0));
		self.ListboxGoldEarned:SetVisible(true);
	
	--Creating Buttons
		--Next Page
			ButtonNP = Turbine.UI.Lotro.Button();
			ButtonNP:SetParent( self );
			ButtonNP:SetText( "Next" );
			ButtonNP:SetPosition( 260, 430 );
			ButtonNP:SetSize( 105, 20 );
			ButtonNP:SetVisible(true);
			
		--Previous page
			ButtonPP = Turbine.UI.Lotro.Button();
			ButtonPP:SetParent( self );
			ButtonPP:SetText( "Previous" );
			ButtonPP:SetPosition( 40, 430 );
			ButtonPP:SetSize( 105, 20 );
			ButtonPP:SetVisible(true);
			
		--Clear data
			ButtonCD = Turbine.UI.Lotro.Button();
			ButtonCD:SetParent( self );
			ButtonCD:SetText( "Clear" );
			ButtonCD:SetPosition( 150, 430 );
			ButtonCD:SetSize( 105, 20 );
			ButtonCD:SetVisible(true);
	
	--Clear button is pressed
		ButtonCD.Click = function( sender, args )
			self.ListboxGoldEarned:ClearItems();
			GoldCollected = 0;
			SilverCollected = 0;
			CopperCollected = 0;
			ArrayData = {};
			table.insert(ArrayData, "");
			--for k,v in pairs(ArrayData) do ArrayData[k]=nil end
			MainWindow:SaveData(ArrayData, Day);
			for i = 1, 22, 1 do
				local label = Turbine.UI.Label();
				label:SetText("");
				label:SetSize(350, 15 );
				label:SetBackColor( Turbine.UI.Color(0.91,0,0,0) );
				label:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
				self.ListboxGoldEarned:AddItem(label);
			end
		end

	--Next Page button is pressed
		ButtonNP.Click = function( sender, args )
			self.ListboxGoldEarned:ClearItems();
			TotalPages = table.getn(ArrayData) / 22;
			TotalPages = round(TotalPages+.5);
			if ( Page < TotalPages ) then
				Page = Page + 1;
			end
			for i = 1, table.getn(ArrayData), 1 do
				local label = Turbine.UI.Label();
				if ( i + (22 * (Page - 1)) <= table.getn(ArrayData) ) then
					MountNumber = i + (22 * (Page - 1));
					label:SetText( ArrayData[MountNumber] );
					label:SetSize(350, 15 );
					label:SetBackColor( Turbine.UI.Color(0.91,0,0,0) );
					label:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
					self.ListboxGoldEarned:AddItem(label);
					if (i == (22 * Page)) then
						break
					end
				end
			end
		end
	
	--Previous page button is pressed
		ButtonPP.Click = function( sender, args )
			if ( Page > 1 ) then
				self.ListboxGoldEarned:ClearItems();
				Page = Page - 1;
				TotalPages = table.getn(ArrayData) / 22;
				TotalPages = round(TotalPages+.5);
				for j = 1, table.getn(ArrayData), 1 do
					local label = Turbine.UI.Label();
					if ( j + (22 * (Page - 1)) <= table.getn(ArrayData) ) then
						MountNumber = j + (22 * (Page - 1));
						label:SetText( ArrayData[MountNumber] );
						label:SetSize(350, 15 );
						label:SetBackColor( Turbine.UI.Color(0.91,0,0,0) );
						label:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
						self.ListboxGoldEarned:AddItem(label);
						if (j == (22 * Page)) then
							break
						end
					end
				end
			end
		end
		
	--Clear the old list
		self.ListboxGoldEarned:ClearItems();
		
	--Load previous data
		if ( Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_GoldEarned") ~= nil ) then
			ArrayData = MainWindow:LoadData()
		end
		MainWindow:LoadDay()
	if PrevDay ~= Day then
		PrevDay = Day;
		NextDay = true;
	else
		
	end
	
	--Update the listbox
	if Turbine.Chat.Received and ArrayData ~= nil then
		self.ListboxGoldEarned:ClearItems();
		for i = 1, table.getn(ArrayData), 1 do
			j = i + ((Page - 1) * 22);
			if j > (((Page - 1) * 22) + 22) then
				break
			end
			local label = Turbine.UI.Label();
			label:SetText(ArrayData[j]);
			label:SetSize(350, 15 );
			label:SetBackColor( Turbine.UI.Color(0.91,0,0,0) );
			label:SetTextAlignment( Turbine.UI.ContentAlignment.Left );
			self.ListboxGoldEarned:AddItem(label);
		end
	end
end
	
function MainWindow:GetDate()
	Year = Date.Year;
	Month = Date.Month;
	Day = Date.Day;
	TotalDate = Day .. "/" .. Month .. "/" .. Year;
end

Turbine.Chat.Received = function(sender,args)
	local ChatType = Turbine.ChatType;
	ChatType = args.ChatType;
	--Turbine.Shell.WriteLine( "Chattype: " .. ChatType .. " Message: " .. args.Message );
	if ChatType == 36 and string.find(args.Message,"You looted") or ChatType == 21 and string.find(args.Message,"You've earned") or ChatType == 4 and string.find(args.Message,"You sold") or ChatType == 4 and string.find(args.Message,"You received") then
		if string.find(args.Message,"gold") then
			local Gold = 0;
			local StringGold = "";
			StringGold = string.match(args.Message, "%d+ gold");
			Gold = string.match(StringGold, "%d+");
			GoldCollected = GoldCollected + Gold;
		end
		if string.find(args.Message,"silver") then
			local Silver = 0;
			local StringSilver = "";
			StringSilver = string.match(args.Message, "%d+ silver");
			Silver = string.match(StringSilver, "%d+");
			SilverCollected = SilverCollected + Silver;
		end
		if string.find(args.Message,"copper") then
			local Copper = 0;
			local StringCopper = "";
			StringCopper = string.match(args.Message, "%d+ copper");
			Copper = string.match(StringCopper, "%d+");
			CopperCollected = CopperCollected + Copper;
		end
		
		if CopperCollected >= 100 then
			CopperCollected = CopperCollected - 100;
			SilverCollected = SilverCollected + 1;
		end
		if SilverCollected >= 1000 then
			SilverCollected = SilverCollected - 1000;
			GoldCollected = GoldCollected + 1;
		end
		--Turbine.Shell.WriteLine( "Gold: " .. GoldCollected .. " Silver: " .. SilverCollected .. " Copper: " .. CopperCollected );
		TotalString = TotalDate .. " Gold: " .. GoldCollected .. " Silver: " .. SilverCollected .. " Copper: " .. CopperCollected;
		if NextDay == true then
			table.insert(ArrayData, TotalString);
			NextDay = false;
		else
			local ArrayCnt = 0;
			ArrayCnt = table.getn(ArrayData);
			if ArrayCnt >= 1 then
				table.remove(ArrayData, ArrayCnt);
			end
			table.insert(ArrayData, ArrayCnt, TotalString);
		end
		LabelEarned2:SetText( "G:" .. GoldCollected .. " S:" .. SilverCollected .. " C:" .. CopperCollected );
		MainWindow:SaveData(ArrayData, Day);
	end
end

function MainWindow:SaveData(Array, Lastday)
	Turbine.PluginData.Save(Turbine.DataScope.Character, "LotroStat_GoldEarned", Array);
	local ArrayLastDay = {};
	table.insert(ArrayLastDay, Lastday);	
		table.insert(ArrayLastDay, CopperCollected);
		table.insert(ArrayLastDay, SilverCollected);
		table.insert(ArrayLastDay, GoldCollected);

	Turbine.PluginData.Save(Turbine.DataScope.Character, "LotroStat_LastDay", ArrayLastDay);
end

function MainWindow:LoadData()
	Array = Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_GoldEarned")
	if Array == nil then
		Array = {};
	end

	return Array
end

function MainWindow:LoadDay()
	local ArrayLoad = {};
	if Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_LastDay") ~= nil then
		ArrayLoad = Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroStat_LastDay")
		if ArrayLoad[1] == Day then
			PrevDay = ArrayLoad[1];
			CopperCollected = ArrayLoad[2];
			SilverCollected = ArrayLoad[3];
			GoldCollected = ArrayLoad[4];
		else
			PrevDay = ArrayLoad[1];
			CopperCollected = 0;
			SilverCollected = 0;
			GoldCollected = 0;
		end
	LabelEarned2:SetText( "G:" .. GoldCollected .. " S:" .. SilverCollected .. " C:" .. CopperCollected );
	end
end

function round(num) 
	return math.floor(num+.5)
end