ToggleWindow = class( Turbine.UI.Window );
Settings = {};

function ToggleWindow:Constructor()
	Turbine.UI.Window.Constructor( self );

	if ( Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroGold_Settings") ~= nil ) then
		Settings = ToggleWindow:loadsettings()
	end
	
	if Settings == nil then
		Settings = {};
		self:SetPosition( 100, 100 );
	else
		self:SetPosition( Settings[1], Settings[2] );
	end
	self:SetSize(35,35);
	self:SetZOrder(70);	
	self:SetVisible( true );
	
	self.button = Turbine.UI.Control();
	self.button:SetParent(self);
	self.button:SetPosition(0,0);
	self.button:SetSize(35,35);
	self.button:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.button:SetBackground("LotroGoldTracker/toggle.tga");
	
	self.button.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left) then
			sender.dragStartX = args.X;
			sender.dragStartY = args.Y;
			sender.dragging = true;
			sender.dragged = false;
			self:SetBackColor( Turbine.UI.Color(0,0,1,0) );
		end
	end
	self.button.MouseUp = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left) then
			if (sender.dragging) then
				sender.dragging = false;
			end
			if not sender.dragged then
				LotroGoldTracker:SetVisible( not LotroGoldTracker:IsVisible() );
			end
			self:SetBackColor( Turbine.UI.Color(0,0,0,0) );
		end	
	end
	self.button.MouseMove = function(sender,args)
		if ( sender.dragging ) then
			local left, top = self:GetPosition();
			self:SetPosition( left + ( args.X - sender.dragStartX ), top + args.Y - sender.dragStartY );
			sender:SetPosition( 0, 0 );
			sender.dragged = true;
			ToggleWindow:savesettings(left, top);
		end
	end
end

function ToggleWindow:savesettings(Left, Top)
	local Array = {};
	table.insert(Array, Left);
	table.insert(Array, Top);
	Turbine.PluginData.Save(Turbine.DataScope.Character, "LotroGold_Settings", Array);
end

function ToggleWindow:loadsettings()
	Array = Turbine.PluginData.Load(Turbine.DataScope.Character, "LotroGold_Settings")
	if Array == nil then
		Array = {};
	end

	return Array
end